%bcond_with cassandane
%bcond_with advance

%define ssl_pem_file_prefix %{_sysconfdir}/pki/%{name}/%{name}
%define cyrexecdir %{_libexecdir}/%{name}

%global testdata_commit ca669d4b76c71cbeb4fa840e263e2c031e19ea88
%global testdata_short %(echo %{testdata_commit} | cut -c -8)
%global __provides_exclude ^perl\\(AnnotateInlinedCIDs\\)$

Summary:  A high-performance email, contacts and calendar server
Name:     cyrus-imapd
Version:  3.4.8
Release:  4%{?dist}
License:  BSD
URL:      http://www.cyrusimap.org/
Source0:  https://github.com/cyrusimap/cyrus-imapd/releases/download/cyrus-imapd-%{version}/cyrus-imapd-%{version}.tar.gz
Source1:  cyrus-imapd.logrotate
Source2:  cyrus-imapd.pam-config
Source3:  cyrus-imapd.sysconfig
Source4:  cyrus-imapd.magic
Source5:  cyrus-imapd.cron-daily
Source6:  cyrus-imapd.service
Source7:  cyrus-imapd-init.service
Source8:  cyrus-imapd.tmpfiles.conf
Source9:  https://github.com/brong/Net-CalDAVTalk/archive/%{testdata_commit}/cassandane-testdata-%{testdata_short}.tar.gz
Source10: cassandane.ini
Source11: patch-cassandane-no-syslog
Source12: patch-cassandane-fix-annotator
Source13: patch-cassandane-xapian-delve-path

Patch3000: patch-cyrus-testsuite-timeout
Patch3001: patch-cyrus-default-configs
Patch3002: patch-cyrus-rename-quota
Patch3003: patch-cyrus-perl-linking
Patch3004: patch-cyrus-squatter-assert-crash

BuildRequires: autoconf automake bison flex gcc gcc-c++ git glibc-langpack-en
BuildRequires: groff libtool make pkgconfig rsync systemd transfig
BuildRequires: perl-devel perl-generators perl(ExtUtils::MakeMaker) perl(Pod::Html) CUnit-devel cyrus-sasl-devel glib2-devel
BuildRequires: jansson-devel krb5-devel libical-devel libicu-devel libnghttp2-devel libxml2-devel mariadb-connector-c-devel net-snmp-devel
BuildRequires: openldap-devel openssl-devel pcre-devel libpq-devel sqlite-devel xapian-core-devel cyrus-sasl-plain cyrus-sasl-md5

%if %{with advance}
BuildRequires: clamav-devel shapelib-devel
%endif

%if %{with cassandane}
BuildRequires: imaptest net-tools words perl-interpreter perl(AnyEvent) perl(AnyEvent::Handle)
BuildRequires: perl(AnyEvent::Socket) perl(AnyEvent::Util) perl(attributes) perl(base) perl(BSD::Resource)
BuildRequires: perl(bytes) perl(Carp) perl(charnames) perl(Clone) perl(Config) perl(Config::IniFiles)
BuildRequires: perl(constant) perl(Cwd) perl(Data::Dumper) perl(DateTime) perl(DateTime::Format::ISO8601)
BuildRequires: perl(Digest::MD5) perl(Encode) perl(Errno) perl(experimental) perl(Exporter) perl(File::Basename)
BuildRequires: perl(File::chdir) perl(File::Find) perl(File::Path) perl(File::Slurp) perl(File::stat)
BuildRequires: perl(File::Temp) perl(Getopt::Long) perl(HTTP::Tiny) perl(IO::File) perl(IO::Handle)
BuildRequires: perl(IO::Scalar) perl(IO::Socket::INET) perl(IO::Socket::INET6) perl(IO::Socket::UNIX) perl(JSON)
BuildRequires: perl(JSON::XS) perl(lib) perl(Mail::IMAPTalk) perl(Mail::JMAPTalk) >= 0.11 perl(Math::Int64)
BuildRequires: perl(MIME::Base64) perl(Net::CalDAVTalk) >= 0.12 perl(Net::CardDAVTalk) >= 0.05
BuildRequires: perl(Net::CardDAVTalk::VCard) perl(Net::DAVTalk) perl(Net::POP3) perl(Net::Server::PreForkSimple)
BuildRequires: perl(News::NNTPClient) perl(overload) perl(POSIX) perl(Scalar::Util) perl(Storable) perl(strict)
BuildRequires: perl(String::CRC32) perl(Sys::Hostname) perl(Sys::Syslog) perl(Test::Unit::Exception)
BuildRequires: perl(Test::Unit::Listener) perl(Test::Unit::Result) perl(Test::Unit::Runner)
BuildRequires: perl(Test::Unit::TestCase) perl(Test::Unit::TestRunner) perl(Time::HiRes) perl(URI)
BuildRequires: perl(URI::Escape) perl(User::pwent) perl(utf8) perl(vars) perl(warnings) perl(XML::DOM)
BuildRequires: perl(XML::Generator) perl(XML::Spice) clamav-data perl(Unix::Syslog) perl(HTTP::Daemon) perl(DBI)
BuildRequires: perl(Net::LDAP::Constant) perl(Net::LDAP::Server) perl(Module::Load::Conditional)
%endif

Requires(pre): shadow-utils
%{?systemd_requires}
Requires: %{name}-utils = %{version}-%{release}
Requires: file sscg
Requires: perl(:MODULE_COMPAT_%{?perl_version})

%{?perl_default_filter}

%description
The Cyrus IMAP (Internet Message Access Protocol) server provides access to personal mail,
system-wide bulletin boards, news-feeds, calendar and contacts through the IMAP, JMAP, NNTP, CalDAV
and CardDAV protocols. The Cyrus IMAP server is a scalable enterprise groupware system designed for
use from small to large enterprise environments using technologies based on well-established Open
Standards.

A full Cyrus IMAP implementation allows a seamless mail and bulletin board environment to be set up
across one or more nodes. It differs from other IMAP server implementations in that it is run on
sealed nodes, where users are not normally permitted to log in. The mailbox database is stored in
parts of the filesystem that are private to the Cyrus IMAP system. All user access to mail is
through software using the IMAP, IMAPS, JMAP, POP3, POP3S, KPOP, CalDAV and/or CardDAV protocols.

The private mailbox database design gives the Cyrus IMAP server large advantages in efficiency,
scalability, and administratability. Multiple concurrent read/write connections to the same mailbox
are permitted. The server supports access control lists on mailboxes and storage quotas on mailbox
hierarchies.

%package devel
Summary: Cyrus IMAP server development files
Requires: %{name} = %{version}-%{release}
Requires: pkgconfig

%description devel
The %{name}-devel package contains header files and libraries necessary for developing applications
which use the imclient library.

%package doc-extra
Summary: Extra documentation for the Cyrus IMAP server
BuildArch: noarch

%description doc-extra
This package contains the HTML documentation for the Cyrus IMAP server, as well as some legacy and
internal documentation not useful for normal operation of the server.

%package libs
Summary: Runtime libraries for cyrus-imapd

%description libs
The cyrus-imapd-libs package contains libraries shared by the Cyrus IMAP server and the its utilities.

%package utils
Summary: Cyrus IMAP server administration utilities
Requires: cyrus-imapd = %{version}-%{release}

%description utils
The cyrus-imapd-utils package contains administrative tools for the Cyrus IMAP server. It can be
installed on systems other than the one running the server.

%package virusscan
Summary: Cyrus virus scanning utility

%description virusscan
The cyrus-imapd-virusscan package contains the cyr_virusscan utility.  It exists in a separate
package so that users who do not wish to install all of the clamav suite don't have to.

Install this package if you wish to use the internal cyrus virus scanning utility.


%package -n perl-Cyrus
Summary: Perl libraries for interfacing with Cyrus IMAPd

%description -n perl-Cyrus
This package contains Perl libraries used to interface with Cyrus IMAPd.

%prep
%autosetup -n %{name}-%{version} -p1
echo %{version} > VERSION

%if %{with cassandane}
pushd cassandane
mkdir work
tar xf %{SOURCE9}

patch -p1 < %{SOURCE11}
patch -p1 < %{SOURCE12}
patch -p1 < %{SOURCE13}

cp %{SOURCE10} cassandane.ini
sed -i \
    -e "s!CASSDIR!$(pwd)!" \
    -e "s!BUILDROOT!%{buildroot}!" \
    cassandane.ini

popd
%endif

sed -i -e '1{/usr.bin.perl/d}' perl/annotator/{Message,Daemon}.pm

sed -i -e '1i#!/usr/bin/perl' -e '1d' tools/rehash

sed -i \
    -e '1i#!/usr/bin/perl -w' \
    -e '/^#!\/usr\/bin\/perl/d' \
    -e '/^exec perl/d' \
    -e '/^#!perl -w/d' \
    -e '/^#!perl/d' \
    -e '/^#!\/bin\/sh/d' \
    -e '/^#! \/bin\/sh/d' \
    perl/sieve/scripts/installsieve.pl \
    perl/sieve/scripts/sieveshell.pl perl/imap/cyradm.sh tools/config2header \
    tools/masssievec tools/config2rst tools/mknewsgroups tools/config2sample \
    tools/mkimap tools/translatesieve


%build
%if %{with cassandane}
pushd cassandane
export NOCYRUS=1
make
popd
%endif

autoreconf -vi

%configure \
    --disable-silent-rules \
    --libexecdir=%cyrexecdir \
    --with-clamav \
    --with-extraident="%{release} %{_vendor}" \
    --with-krbimpl=mit \
    --with-ldap=/usr \
    --with-libwrap=no \
    --with-mysql \
    --with-pgsql \
    --with-perl=%__perl \
    --with-snmp \
    --with-syslogfacility=MAIL \
    --enable-autocreate \
    --enable-backup \
    --enable-calalarmd \
    --enable-http \
    --enable-idled \
    --enable-murder \
    --enable-nntp \
    --enable-replication \
    --enable-unit-tests \
    --enable-xapian \
    %{nil}

sed -i 's|^hardcode_libdir_flag_spec=.*|hardcode_libdir_flag_spec=""|g' libtool
sed -i 's|^runpath_var=LD_RUN_PATH|runpath_var=DIE_RPATH_DIE|g' libtool

for i in perl/annotator perl/imap perl/sieve/managesieve; do
    pushd $i
    rm -f Makefile
    perl Makefile.PL INSTALLDIRS=vendor
    popd
done

%make_build

make notifyd/notifytest


%install
make install DESTDIR=%{buildroot}

install -d \
    %{buildroot}%{_sysconfdir}/{rc.d/init.d,logrotate.d,pam.d,sysconfig,cron.daily} \
    %{buildroot}%{_libdir}/sasl \
    %{buildroot}/var/spool/imap \
    %{buildroot}/var/lib/imap/{user,quota,proc,log,msg,socket,db,sieve,sync,md5,rpm,backup,meta} \
    %{buildroot}/var/lib/imap/ptclient \
    %{buildroot}%{_datadir}/%{name}/rpm \
    %{buildroot}/%cyrexecdir \
    %{buildroot}%{_sysconfdir}/pki/%{name}

install -d -m 0750 \
    %{buildroot}/run/cyrus \
    %{buildroot}/run/cyrus/socket

install -d -m 0700 \
    %{buildroot}/run/cyrus/db \
    %{buildroot}/run/cyrus/lock \
    %{buildroot}/run/cyrus/proc

install -m 755 notifyd/notifytest  %{buildroot}%_bindir/
install -m 755 perl/imap/cyradm    %{buildroot}%_bindir/
for i in arbitronsort.pl masssievec mkimap mknewsgroups rehash translatesieve; do
    install -m 755 tools/$i %{buildroot}/%cyrexecdir/
done

install -p -m 644 %{SOURCE1} %{buildroot}%{_sysconfdir}/logrotate.d/%{name}

install -p -m 644 %{SOURCE2} %{buildroot}%{_sysconfdir}/pam.d/csync
install -p -m 644 %{SOURCE2} %{buildroot}%{_sysconfdir}/pam.d/http
install -p -m 644 %{SOURCE2} %{buildroot}%{_sysconfdir}/pam.d/imap
install -p -m 644 %{SOURCE2} %{buildroot}%{_sysconfdir}/pam.d/lmtp
install -p -m 644 %{SOURCE2} %{buildroot}%{_sysconfdir}/pam.d/mupdate
install -p -m 644 %{SOURCE2} %{buildroot}%{_sysconfdir}/pam.d/nntp
install -p -m 644 %{SOURCE2} %{buildroot}%{_sysconfdir}/pam.d/pop
install -p -m 644 %{SOURCE2} %{buildroot}%{_sysconfdir}/pam.d/sieve

install -p -m 644 %{SOURCE3} %{buildroot}%{_sysconfdir}/sysconfig/%{name}
install -p -m 644 %{SOURCE4} %{buildroot}/%{_datadir}/%{name}/rpm/magic
install -p -m 755 %{SOURCE5} %{buildroot}%{_sysconfdir}/cron.daily/%{name}
install -p -m 644 doc/examples/cyrus_conf/prefork.conf %{buildroot}%{_sysconfdir}/cyrus.conf
install -p -m 644 doc/examples/imapd_conf/normal.conf %{buildroot}%{_sysconfdir}/imapd.conf
install -p -D -m 644 %{SOURCE6} %{buildroot}/%_unitdir/cyrus-imapd.service
install -p -D -m 644 %{SOURCE7} %{buildroot}/%_unitdir/cyrus-imapd-init.service
install -p -D -m 644 %{SOURCE8} %{buildroot}/%_tmpfilesdir/cyrus-imapd.conf

find doc perl -name CVS -type d -prune -exec rm -rf {} \;
find doc perl -name .cvsignore -type f -exec rm -f {} \;
rm -f doc/Makefile.dist*
rm -f doc/text/htmlstrip.c
rm -f doc/text/Makefile
rm -rf doc/man

find %{buildroot}%{_libdir}/perl5/ -type f -name "*.so" -exec chmod 755 {} \;

( grep '^{' lib/imapoptions | grep _db | cut -d'"' -f 2,4 | \
  sed -e 's/^ *//' -e 's/-nosync//' -e 's/ *$//' -e 's/"/=/'
  echo sieve_version=2.2.3 ) | sort > %{buildroot}/%{_datadir}/%{name}/rpm/db.cfg



mv %{buildroot}%{_sbindir}/fetchnews %{buildroot}%{_sbindir}/cyr_fetchnews
mv %{buildroot}%{_mandir}/man8/fetchnews.8 %{buildroot}%{_mandir}/man8/cyr_fetchnews.8

mv %{buildroot}%{_sbindir}/restore %{buildroot}%{_sbindir}/cyr_restore
mv %{buildroot}%{_mandir}/man8/restore.8 %{buildroot}%{_mandir}/man8/cyr_restore.8

mv %{buildroot}%{_sbindir}/quota %{buildroot}%{_sbindir}/cyr_quota
mv %{buildroot}%{_mandir}/man8/quota.8 %{buildroot}%{_mandir}/man8/cyr_quota.8

mv %{buildroot}%{_mandir}/man8/imapd.8 %{buildroot}%{_mandir}/man8/imapd.8cyrus
mv %{buildroot}%{_mandir}/man8/pop3d.8 %{buildroot}%{_mandir}/man8/pop3d.8cyrus

mv %{buildroot}%{_mandir}/man8/master.8 %{buildroot}%{_mandir}/man8/master.8cyrus

mv %{buildroot}%{_mandir}/man8/httpd.8 %{buildroot}%{_mandir}/man8/httpd.8cyrus

mkdir %{buildroot}/usr/lib/cyrus-imapd
pushd %{buildroot}/usr/lib/cyrus-imapd
ln -s ../../sbin/deliver
popd

for ddir in doc perl/imap/examples
do
  find $ddir -type f -exec chmod -x {} \;
done

rm %{buildroot}%{_libdir}/*.la

rm %{buildroot}/%cyrexecdir/pop3proxyd
find %{buildroot} -name "perllocal.pod" -exec rm {} \;
find %{buildroot} -name ".packlist" -exec rm {} \;

chmod -x %{buildroot}/%perl_vendorlib/Cyrus/Annotator/Daemon.pm


%check
export LD_LIBRARY_PATH=%{buildroot}%{_libdir}
export CYRUS_USER=$USER

%ifnarch ppc64le
%make_build check || exit 1
%endif

%if %{with cassandane}

pushd cassandane

mkdir -p imaptest/src
ln -s /usr/bin/imaptest imaptest/src
ln -s /usr/share/imaptest/tests imaptest/src

exclude=()
tests=(
    Cassandane::Test::Core

    Admin.imap_admins

    Rename.intermediate_cleanup

    Cyrus::List.no_tombstones
    Reconstruct.reconstruct_snoozed
    SearchSquat.simple
    SearchSquat.skip_unmodified
)
for i in ${tests[@]}; do exclude+=("!$i"); done

./testrunner.pl %{?_smp_mflags} -v -f pretty ${exclude[@]} 2>&1
%endif


%pre
getent group saslauth >/dev/null || /usr/sbin/groupadd -g 76 -r saslauth
getent passwd cyrus >/dev/null || /usr/sbin/useradd -c "Cyrus IMAP Server" -d /var/lib/imap -g mail \
  -G saslauth -s /sbin/nologin -u 76 -r cyrus

%post
%systemd_post cyrus-imapd.service

%preun
%systemd_preun cyrus-imapd.service

%postun
%systemd_postun_with_restart cyrus-imapd.service

%files
%doc README.md doc/README.* doc/examples doc/text
%dir %{_sysconfdir}/pki/cyrus-imapd
%attr(0644,root,mail) %ghost %config(missingok,noreplace) %verify(not md5 size mtime) %ssl_pem_file_prefix-ca.pem
%attr(0644,root,mail) %ghost %config(missingok,noreplace) %verify(not md5 size mtime) %ssl_pem_file_prefix.pem
%attr(0640,root,mail) %ghost %config(missingok,noreplace) %verify(not md5 size mtime) %ssl_pem_file_prefix-key.pem
%config(noreplace) %{_sysconfdir}/cyrus.conf
%config(noreplace) %{_sysconfdir}/imapd.conf
%config(noreplace) %{_sysconfdir}/logrotate.d/cyrus-imapd
%config(noreplace) %{_sysconfdir}/sysconfig/cyrus-imapd
%config(noreplace) %{_sysconfdir}/pam.d/*

%{_sysconfdir}/cron.daily/cyrus-imapd
%{_unitdir}/cyrus-imapd.service
%{_unitdir}/cyrus-imapd-init.service
%{_tmpfilesdir}/cyrus-imapd.conf

%dir %cyrexecdir/
%cyrexecdir/[a-uw-z]*

%attr(0750,cyrus,mail) %dir /var/lib/imap/
%attr(0700,cyrus,mail) /var/lib/imap/backup/
%attr(0700,cyrus,mail) /var/lib/imap/db/
%attr(0700,cyrus,mail) /var/lib/imap/log/
%attr(0700,cyrus,mail) /var/lib/imap/meta/
%attr(0700,cyrus,mail) /var/lib/imap/md5/
%attr(0700,cyrus,mail) /var/lib/imap/msg/
%attr(0700,cyrus,mail) /var/lib/imap/proc/
%attr(0700,cyrus,mail) /var/lib/imap/ptclient/
%attr(0700,cyrus,mail) /var/lib/imap/quota/
%attr(0700,cyrus,mail) /var/lib/imap/rpm/
%attr(0700,cyrus,mail) /var/lib/imap/sieve/
%attr(0750,cyrus,mail) /var/lib/imap/socket
%attr(0700,cyrus,mail) /var/lib/imap/sync/
%attr(0700,cyrus,mail) /var/lib/imap/user/
%attr(0700,cyrus,mail) /var/spool/imap/
%attr(0750,cyrus,mail) %dir /run/cyrus/
%attr(0700,cyrus,mail) /run/cyrus/db/
%attr(0700,cyrus,mail) /run/cyrus/lock/
%attr(0700,cyrus,mail) /run/cyrus/proc/
%attr(0750,cyrus,mail) /run/cyrus/socket/
/usr/lib/cyrus-imapd/
%{_sbindir}/*
%{_datadir}/cyrus-imapd
%{_mandir}/man5/*
%{_mandir}/man8/*
%exclude %{_sbindir}/cyr_virusscan
%exclude %{_mandir}/man8/cyr_virusscan.8*

%files devel
%{_includedir}/cyrus/
%{_libdir}/libcyrus*.so
%{_libdir}/pkgconfig/*.pc
%{_mandir}/man3/imclient.3*

%files doc-extra
%doc doc/html doc/internal doc/legacy

%files libs
%license COPYING
%{_libdir}/libcyrus*.so.*

%files utils
%{_bindir}/*
%{_mandir}/man1/*

%files virusscan
%{_sbindir}/cyr_virusscan
%{_mandir}/man8/cyr_virusscan.8*

%files -n perl-Cyrus
%license COPYING
%doc perl/imap/README
%doc perl/imap/Changes
%doc perl/imap/examples
%perl_vendorarch/auto/Cyrus
%perl_vendorarch/Cyrus
%perl_vendorlib/Cyrus
%{_mandir}/man3/*.3pm*

%changelog
* Mon Dec 23 2024 Rebuild Robot <rebot@opencloudos.org> - 3.4.8-4
- [Type] other
- [DESC] Rebuilt for icu

* Thu Sep 26 2024 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 3.4.8-3
- Rebuilt for clarifying the packages requirement in BaseOS and AppStream

* Fri Aug 16 2024 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 3.4.8-2
- Rebuilt for loongarch release

* Wed Jun 26 2024 Weiyao Feng <wynnfeng@tencent.com> - 3.4.8-1
- [type] security
- [desc] upgrade to 3.4.8 to fix CVE-2024-34055

* Tue Mar 19 2024 Rebuild Robot <rebot@opencloudos.org> - 3.4.4-8
- Rebuilt for jansson

* Fri Sep 08 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 3.4.4-7
- Rebuilt for OpenCloudOS Stream 23.09

* Wed Aug 23 2023 rockerzhu <rockerzhu@tencent.com> - 3.4.4-6
- Rebuilt for icu 73.2

* Fri Aug 18 2023 Wang Guodong <gordonwwang@tencent.com> - 3.4.4-5
- Rebuilt for mariadb-connector-c 3.3.5

* Thu Aug 3 2023 Shuo Wang <abushwang@tencent.com> - 3.4.4-4
- Rebuilt for libpq 15.3

* Fri Apr 28 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 3.4.4-3
- Rebuilt for OpenCloudOS Stream 23.05

* Fri Mar 31 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 3.4.4-2
- Rebuilt for OpenCloudOS Stream 23

* Tue Mar 28 2023 Shuo Wang <abushwang@tencent.com> - 3.4.4-1
- initial build
